'''A Basic Monster Race for D&D CSS'''

import es, dnds, popuplib
from dnds import dnds

def load():
    dnds.addRace('Dragon', monsterRace=True, bpRequired=7, bonusWeapons=dnds.Weapons)
    
    dragoninfo = popuplib.create('dragoninfo')
    dragoninfo.addline('-{ D&D CS:S - Dragon Info }-')
    dragoninfo.addline(' Required Bonus Points: 7')
    dragoninfo.addline(' Weapons: All ')
    dragoninfo.addline(' +4000 Cash on Spawn ')
    dragoninfo.addline(' 125 Health')
    dragoninfo.addline(' Commands:')
    dragoninfo.addline(' - lev0 (Normal Gravity)')
    dragoninfo.addline(' - lev1 (50% Gravity)')
    dragoninfo.addline(' - lev2 (20% Gravity)')
    dragoninfo.addline(' - lev3 (1% Gravity)')
    dragoninfo.addline('-> 8. Back')
    dragoninfo.addline('0. Exit')
    dragoninfo.submenu(8, 'monracesinfo 1')
    dnds.addRaceInformation('Dragon', 'dragoninfo', monsterRace=True, bpRequired=7)

    for c in ['lev0', 'lev1', 'lev2', 'lev3']:
        dnds.Commands[c]['Races'].append('Dragon')

def player_spawn(ev):
    userid = int(ev['userid'])
    if dnds.isRace(userid, 'dragon'):
        dnds.Health(userid, 25)
        dnds.Cash(userid, 4000)
        dnds.Regeneration(userid, 2, 1)
