'''A Class for D&D 3.5 Mod'''

import es, dnds, popuplib, random
from dnds import dnds

def load():
    dnds.addClass('Rogue', dnds.SMGs+dnds.Grenades+dnds.Pistols+['scout','knife'])

    rogueinfo = popuplib.create('rogueinformation')
    rogueinfo.addline('-{ D&D CS:S - Rogue }-')
    rogueinfo.addline(' Weapons: SMGs, Pistols, and Scout ')
    rogueinfo.addline(' Stealthed - When walking/crouching')
    rogueinfo.addline(' Sneak Attack - Additional damage when stealthed')
    rogueinfo.addline('-> 1. Powers')
    rogueinfo.addline('-> 7. Play as a Rogue')
    rogueinfo.addline('-> 8. Back')
    rogueinfo.addline('0. Exit')
    rogueinfo.submenu(1, 'roguepowers')
    rogueinfo.submenu(8, 'classinfo 1')
    rogueinfo.menuselect = rogueMenuSelect
    dnds.addClassInformation('Rogue', 'rogueinformation')

    pwrsinfo = popuplib.create('roguepowers')
    pwrsinfo.addline('-{ D&D CS:S - Powers }-')
    pwrsinfo.addline(' Lvl 2: Evasion - Chance to dodge attacks')
    pwrsinfo.addline(' Lvl 3: Trap Sense - Know when others are nearby')
    pwrsinfo.addline(' Lvl 4: Uncanny Dodge - Dodge first attack each round')
    pwrsinfo.addline(' Lvl 8: Improved Uncanny - Dodge the second attack as well')
    pwrsinfo.addline(' Lvl 10: Crippling Strike - Your sneak attacks cripple their victim')
    pwrsinfo.addline(' Lvl 13: Disarm - Have a chance to disarm your victim')
    pwrsinfo.addline(' Lvl 16: Improved Evasion - Increased dodge chance')
    pwrsinfo.addline(' Lvl 19: Opportunist - You may randomly sneak attack anytime')
    pwrsinfo.addline('-> 8. Back')
    pwrsinfo.addline('0. Exit')
    pwrsinfo.submenu(8, 'rogueinformation')

def rogueMenuSelect(userid, choice, popupid):
    if choice == 7:
        Key = dnds.getPlayer(userid)
        Key['delayed']['class'] = 'Rogue'
        es.tell(userid, '#multi', 'You will be a Rogue once the round ends')

def player_spawn(ev):
    userid = int(ev['userid'])
    Key = dnds.getPlayer(userid)
    Key['uncanny'] = False
    if dnds.isClass(userid, 'Rogue'):
        level = dnds.getLevel(userid, 'Rogue')
        #es.msg(level)
        Key['color'] -= (195+((level/4)*10))
        Key['Sneak Dice'] += max(level/5, 1)
        if level >= 2:
            Key['dodge max damage'] = 100
            Key['dodge percent'] += 10
        if level >= 3:
            Key['thermal range'] = 360
        if level >= 4:
            Key['uncanny'] = 1
            Key['dodge percent'] += 100
        if level >= 8:
            Key['uncanny'] += 1
        if level >= 9:
            Key['thermal range'] += 120
        if level >= 15:
            Key['thermal range'] += 120
        if level >= 16:
            Key['dodge percent'] += 5
        if level >= 18:
            Key['thermal range'] += 120

def player_hurt(ev):
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    if attacker and userid:
        if dnds.isClass(userid, 'Rogue'):
            level = dnds.getLevel(userid, 'Rogue')
            Key = dnds.getPlayer(userid)
            if Key['uncanny']:
                Key['uncanny'] -= 1
                if not Key['uncanny']:
                    Key['dodge max damage'] -= 1000
                    Key['dodge percent'] -= 100
        if dnds.isClass(attacker, 'Rogue'):
            if attacker:
                Key = dnds.getPlayer(attacker)
                level = dnds.getLevel(attacker, 'Rogue')
                if level >= 19:
                    if not random.randrange(19):
                        es.event('initialize', 'sneak_attack')
                        es.event('setint',     'sneak_attack', 'userid', ev['userid'])
                        es.event('setint',     'sneak_attack', 'attacker', ev['attacker'])
                        es.event('setint',     'sneak_attack', 'damage', ev['dmg_health'])
                        es.event('fire',       'sneak_attack')
                if level >= 13:
                    if not random.randrange(8):
                        es.server.queuecmd('est_DropWeapon %s 1'%userid)

def sneak_attack(ev):
    attacker = int(ev['attacker'])
    userid = int(ev['userid'])
    Key = dnds.getPlayer(attacker)
    if dnds.isClass(attacker, 'Rogue'):
        #es.msg('is rogue')
        level = dnds.getLevel(attacker, 'Rogue')
        dice = Key['Sneak Dice']
        bonus = random.randrange(dice*5, dice*30, 5)
        es.tell(attacker, '#multi', '#defaultYou have dealt %s bonus damage with a sneak attack!'%bonus)
        dnds.Damage(userid, attacker, bonus)
        if level >= 10:
            dnds.Stun(userid, 5)
